VERSION 5.00
Begin VB.Form Form2 
   Caption         =   "DirWatchTargetWindow"
   ClientHeight    =   6030
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10740
   LinkTopic       =   "Form2"
   ScaleHeight     =   6030
   ScaleWidth      =   10740
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdNoWindir 
      Caption         =   "UnWatch Windir"
      Height          =   495
      Left            =   5340
      TabIndex        =   4
      Top             =   4980
      Width           =   1815
   End
   Begin VB.CommandButton cmdWindir 
      Caption         =   "Watch Windir"
      Height          =   495
      Left            =   3960
      TabIndex        =   3
      Top             =   4980
      Width           =   1215
   End
   Begin VB.CommandButton cmdUnWatchTMP 
      Caption         =   "UnWatchTMP"
      Height          =   495
      Left            =   1620
      TabIndex        =   2
      Top             =   4980
      Width           =   1215
   End
   Begin VB.CommandButton cmdWatchTMP 
      Caption         =   "Watch TEMP"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   4980
      Width           =   1215
   End
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4920
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   10635
   End
End
Attribute VB_Name = "Form2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'I used my subclass library for simplicity, you can use whatever sub
'class technique or inline code you desire...
Dim WithEvents sc As clsSubClass
Attribute sc.VB_VarHelpID = -1


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Declare Function StartWatch Lib "dir_watch.dll" (ByVal dirPath As String) As Long
Private Declare Function CloseWatch Lib "dir_watch.dll" (ByVal threadID As Long) As Long

Const WM_COPYDATA = &H4A
Const WM_DISPLAY_TEXT = 3

Private Type COPYDATASTRUCT
    dwFlag As Long
    cbSize As Long
    lpData As Long
End Type

Dim tid1 As Long
Dim tid2 As Long


Private Sub cmdNoWindir_Click()
    If tid2 > 0 Then tid2 = CloseWatch(tid2)
End Sub

Private Sub cmdUnWatchTMP_Click()
    If tid1 > 0 Then tid1 = CloseWatch(tid1)
End Sub

Private Sub cmdWatchTMP_Click()
    Dim t As String
    
    t = Environ("TEMP")
    If Len(t) = 0 Then
        MsgBox "Enviroment variant TEMP not set exiting"
        Exit Sub
    End If
    
    tid1 = StartWatch(t)
    
End Sub

Private Sub cmdWindir_Click()
    Dim t As String
    
    t = Environ("WINDIR")
    If Len(t) = 0 Then
        MsgBox "Enviroment variant WINDIR not set exiting"
        Exit Sub
    End If
    
    tid2 = StartWatch(t)
End Sub

Private Sub Form_Load()
    
    Set sc = New clsSubClass
    sc.AttachMessage Me.hwnd, WM_COPYDATA
       
End Sub

Private Sub sc_MessageReceived(hwnd As Long, wMsg As Long, wParam As Long, lParam As Long, Cancel As Boolean)
    
    If wMsg = WM_COPYDATA Then RecieveTextMessage lParam
    
End Sub


Private Sub RecieveTextMessage(lParam As Long)
   
    Dim CopyData As COPYDATASTRUCT
    Dim Buffer(1 To 2048) As Byte
    Dim Temp As String
    
    CopyMemory CopyData, ByVal lParam, Len(CopyData)
    
    If CopyData.dwFlag = 3 Then
        CopyMemory Buffer(1), ByVal CopyData.lpData, CopyData.cbSize
        Temp = StrConv(Buffer, vbUnicode)
        Temp = Left$(Temp, InStr(1, Temp, Chr$(0)) - 1)
        'heres where we work with the intercepted message
        List1.AddItem Temp
    End If
    
End Sub



Function FileExists(path) As Boolean
  If Len(path) = 0 Then Exit Function
  If Dir(path, vbHidden Or vbNormal Or vbReadOnly Or vbSystem) <> "" Then FileExists = True
End Function




